/* 

Geländer für Spur 0 Fahrzeuge
Parametrierbar
-------------------------

*/

// Variablendeklaration
$breit = 45; // Breite des Geländers.

$durch = 1; // Durchmesser des Geländers

$bremse = 1; // 1 = Bremshebel wird gedruckt. 0 = Bremshebel wird nicht gedruckt

$durchgang = 0; // 0 = Durchgang Offen. 1 = Durchgang Geschlossen


// Interne Brechnungen, bitte nicht ändern

$fn=60; // Rundheit der Zylinder

eps = 0.01; // Zugabe um sicher verbundene Objekte zu bekommen.

$bh = $breit/2;

// Konstruktion 

// Modul für die reeling
module reeling(){ 
   
    translate([5, 0, 11])
   rotate([90, 0, 180])union(){
    rotate_extrude(angle=90, convexity=10)
   translate([5, 0]) circle(d=$durch);
translate([5, eps, 0])
   rotate([90, 0, 0]) cylinder(d=$durch, h=11+eps);
 
 translate([-2.5, eps-10, 0])
   rotate([90, 0, 0]) cylinder(d=$durch+0.5, h=1+eps);

 translate([5, eps-10, 0])
   rotate([90, 0, 0]) cylinder(d=$durch+0.5, h=1+eps);

 translate([-10.7, eps-10, 0])
   rotate([90, 0, 0]) cylinder(d=$durch+0.5, h=1+eps);
       
       
  translate([-(12+eps),5,0])rotate([90, 0, 90])cylinder(d=$durch, h=12+eps);
 

translate([-2.5, 5+eps, 0])
   rotate([90, 0, 0]) cylinder(d=$durch, h=16+eps);



translate([-2.5,5,0])sphere(d=$durch+0.5);

translate([-10.75, 5+eps, 0])
   rotate([90, 0, 0]) cylinder(d=$durch, h=16+eps);

translate([-10.75,5,0])sphere(d=$durch+0.5);
    }
}

//Grundplatte
color("tan")cube([1.8, $breit-1, 1.5],true);
 
color("Gold"){ 
translate([0,-($bh-1.5),0])rotate([0,0,90])reeling();    
translate([0,($bh-1.5),0])rotate([0,0,-90])reeling();    

}

// Bremse

if($bremse==1){
translate([0.5,$bh/2,0])cylinder(d=0.8, h=18+eps);

translate([0.5,$bh/2,17.4])minkowski(){cylinder(d=0.7, h=0.6+eps);
    sphere(0.2);}

translate([0.5,$bh/2,17.2])cylinder(d=1.1, h=0.5);

 translate([0.5,$bh/2,18.6])rotate([-90,90,90])  rotate_extrude(angle=90, convexity=10)
   translate([1, 0]) circle(d=0.5);
translate([0.5,$bh/2-1,18.5])minkowski(){cylinder(d=0.2, h=0.2+eps);
    sphere(0.3);}
    
translate([0.5,$bh/2+2.8,17.65])rotate([90,0,0])cylinder(d=0.45, h=3.0);
translate([0.3,$bh/2,15.50])difference(){
    rotate([0,0,90])cylinder(d=$durch+0.5, h=$durch);
    translate([-1.5,0,0.5])cube(3, true);
}
translate([0.0,$bh/2-0.96,15.50])cube([0.5,1.9,$durch]);
} 

// Durchgang

if($durchgang==1){

translate([0, 0, 16.0])
   rotate([90, 0, 0]) cylinder(d=$durch, h=11+eps, center=true);

}